
 // if ErrFlg != 0, the voltage open-circuit error occurs, while the bit0 stand for cell 0, and so on..
//UINT16 avrgU = 0; //the modfied average cell voltage
#include "AppSignal.h"
void SFM(void)
{
    static UINT16 CellUAry[3][32]={0};
    static BOOL   FirstFlg = true;
    static UINT32 RecFlg=0;
    static UINT32 changeFlg=0;
    static UINT32 ErrUFlg = 0;
    static UINT32 intiFlg = 0;
	UINT16 avrgU;
    UINT8 i;
    UINT8 j;
    UINT8 k;
    UINT32 SumU;
    UINT8 Num;
    UINT16 MinU;
    UINT16 MaxU;
//--------------------上电第一时刻对矩阵CellUAry（保存3s电压）初始赋值----------------------
    if(FirstFlg)
    {
        for (j = 0U; j < 3; j++)
        {
            for (i = 0U; i < AppNVMData.BattCellCount; i++)
            {
                CellUAry[j][i] = battCellU[i];
            }
        }
    }
    FirstFlg=false;
    
//--------------------矩阵周期迭代数据，最新电压放置最后一行----------------------
    for (j = 0U; j < 2; j++)
    {
        for (i = 0U; i < AppNVMData.BattCellCount; i++)
        {
            CellUAry[j][i] = CellUAry[j+1][i];
        }
    }
    for (i = 0U; i < AppNVMData.BattCellCount; i++)
    {
        CellUAry[2][i] = battCellU[i];
    }
    
//-------------相邻单体电压2s内（前降后升50mv）连续两次或者单次 最近1s变化满足1000mv-------------------
    for (i = 0U; i < AppNVMData.BattCellCount - 1; i++)
    {
        if ((((INT16)(CellUAry[2][i] - CellUAry[0][i]) <-50) && ((INT16)(CellUAry[2][i+1] - CellUAry[0][i+1]) >50)&&((changeFlg>>i)&0x01)==0x01) ||((INT16)(CellUAry[2][i] - CellUAry[1][i]) <-1000) && ((INT16)(CellUAry[2][i+1] - CellUAry[1][i+1]) >1000) )
        {
            ErrFlg = ErrFlg |(1<<i);
            ErrUFlg = ErrUFlg |(1<<i);
            ErrUFlg = ErrUFlg |(1<<(i+1));
        }
        if (((INT16)(CellUAry[2][i] - CellUAry[0][i]) <-50) && ((INT16)(CellUAry[2][i+1] - CellUAry[0][i+1]) >50))
        {
            changeFlg = changeFlg |(1<<i);
        }
        else
        {
            changeFlg = changeFlg&(~(1<<i));
        }
    }

//-----------------从判断故障单体编号           向前循环判断单体电压是否下降超过200mv----------------------------------------------
    for (i = 1U; i < AppNVMData.BattCellCount; i++)
    {
        if(((ErrFlg>>i)&0x01)==0x01)
        {
            for (k = 1U; k < i; k++)
            {
                if((INT16)(CellUAry[2][i-k] - CellUAry[1][i-k]) <-200)
                {
                    ErrFlg = ErrFlg |(1<<(i-k));
                    ErrUFlg = ErrUFlg |(1<<(i-k));
                }
                else
                {
                    break;
                }
            }
        }
    }
    
//-----------------------B0开路:0 1 2 单体下降1000mv--- -------------------------
    if(((INT16)(CellUAry[2][0] - CellUAry[1][0]) <-1000)&&((INT16)(CellUAry[2][1] - CellUAry[1][1]) <-1000)&&((INT16)(CellUAry[2][2] - CellUAry[1][2]) <-1000))
    {
        ErrUFlg = ErrUFlg|0x07;
    }
    
//-----------------------求正常单体电压的平均--------------------
    SumU=0;
    Num=0;
    MinU=battCellU[0];
    MaxU=battCellU[0];
    for (i = 0U; i < AppNVMData.BattCellCount ; i++)
    {
        if ( ((ErrUFlg>>i)&0x01) == 0)
        {
            SumU=SumU+battCellU[i];
            Num++;
            if(MinU>battCellU[i])
            {
                MinU=battCellU[i];
            }
            if(MaxU<battCellU[i])
            {
                MaxU=battCellU[i];
            }
        }
    }
    if(MaxU-MinU>3000)
    {
        avrgU=(SumU-MaxU-MinU)/(Num-2);
    }
    else
    {
        avrgU=SumU/Num;
    }
//----------------------若上电初始已开路，无变化趋势，则采用压差判断-----------------------------------
    if(MaxU-MinU>3000)
    {
        for (i = 0U; i < AppNVMData.BattCellCount ; i++)
        {   if ( ((ErrUFlg>>i)&0x01) == 0)
            {
                if((((INT16)(battCellU[i]-avrgU)>1500)||((INT16)(battCellU[i]-avrgU)<-1500))&&((intiFlg>>i)&0x01)==0x01)
                {
                    ErrUFlg = ErrUFlg |(1<<i);
                    ErrFlg = ErrFlg |(1<<i);
                }
                if(((INT16)(battCellU[i]-avrgU)>1500)||((INT16)(battCellU[i]-avrgU)<-1500))
                {
                    intiFlg = intiFlg |(1<<i);
                }
                else
                {
                    intiFlg = intiFlg&(~(1<<i));
                }
            }
        }
    }
    
//----------------------恢复条件：在平均电压的-200~200mv之间的连续两次----------------
    for (i = 0U; i < AppNVMData.BattCellCount ; i++)
    {
        if (((INT16)(battCellU[i]-avrgU) > -200) &&((INT16)(battCellU[i]-avrgU) < 200 && ((ErrUFlg>>i)&0x01==1))&& ((RecFlg>>i)&0x01==1))
        {
            ErrFlg = ErrFlg&(~(1<<i)); 
            ErrUFlg = ErrUFlg&(~(1<<i)); 
        }
        if (((INT16)(battCellU[i]-avrgU) > -200) &&((INT16)(battCellU[i]-avrgU) < 200 && ((ErrUFlg>>i)&0x01==1)))
        {
            RecFlg = RecFlg |(1<<i);
        }
        else
        {
            RecFlg = RecFlg&(~(1<<i));
        }
    }
    
}


